const LEVELS = [
    {
        environment: { path: '/', files: [ { filename: 'PDF-Dokument', data: 'pdf', type: 'application/pdf' } ] },
        html: 'Öffne die Datei <code>PDF-Dokument</code>.',
        onopen(file) { return (file.data == 'pdf'); }
    },
    {
        environment: { path: '/', files: [ { filename: 'PDF-Dokument', data: 'pdf', type: 'application/pdf' } ] },
        html: 'Hat das nicht geklappt? Vielleicht liegt das an der fehlenden Dateinamenserweiterung. Ergänze diese, indem du die Datei in <code>PDF-Dokument.pdf</code> umbenennst.',
        onchange() {
            var file = this._root.getByPath('/PDF-Dokument.pdf');
            return (file && (file.data == 'pdf') && (this._root._data.length == 1));
        }
    },
    {
        environment: { path: '/', files: [ { filename: 'PDF-Dokument.pdf', data: 'pdf', type: 'application/pdf' } ] },
        html: 'Erstelle eine neue Datei mit dem Namen <code>infos.txt</code>.',
        onchange() {
            var file = this._root.getByPath('/infos.txt');
            return (file && (file.data != 'pdf'));
        }
    },
    {
        environment: { path: '/', files: [
            { filename: 'PDF-Dokument.pdf', data: 'pdf', type: 'application/pdf' },
            { filename: 'infos.txt', data: 'infos.txt', type: 'text/plain' }
        ] },
        html: 'Erstelle nun einen Ordner mit dem Namen <code>Ordner</code>.',
        onchange() {
            var dir = this._root.getByPath('/Ordner');
            return (dir && dir.isDir);
        }
    },
    {
        environment: { path: '/', files: [
            { filename: 'PDF-Dokument.pdf', data: 'pdf', type: 'application/pdf' },
            { filename: 'infos.txt', data: 'infos.txt', type: 'text/plain' },
            { filename: 'Ordner', data: [] }
        ] },
        html: '<code>Ordner</code> ist doch ein doofer Name. Benenne den Ordner um in <code>geheim</code>.',
        onchange() {
            var dir = this._root.getByPath('/geheim');
            if (!dir || !dir.isDir)
                return false;
            var file = this._root.getByPath('/PDF-Dokument.pdf');
            if (!file || (file.data != 'pdf'))
                return false;
            file = this._root.getByPath('/infos.txt');
            if (!file || (file.data != 'infos.txt'))
                return false;
            return (this._root._data.length == 3);
        }
    },
    {
        environment: { path: '/', files: [
            { filename: 'PDF-Dokument.pdf', data: 'pdf', type: 'application/pdf' },
            { filename: 'infos.txt', data: 'infos.txt', type: 'text/plain' },
            { filename: 'geheim', data: [] }
        ] },
        html: 'Lösche alle Dateien.',
        onchange() {
            var dir = this._root.getByPath('/geheim');
            if (!dir || !dir.isDir)
                return false;
            return (this._root._data.length == 1);
        }
    },
    {
        environment: { path: '/', files: [
            { filename: 'geheim', data: [] }
        ] },
        html: 'Den Ordner kannst du jetzt auch löschen.',
        onchange() {
            return (this._root._data.length == 0);
        }
    },
    {
        environment: { path: '/', files: [
            { filename: 'tränenüberströmt.jpg', data: 'foto', type: 'image/jpeg' },
            { filename: 'präsentation.odp', data: 'praesentation', type: 'application/vnd.oasis.opendocument.presentation' },
            { filename: 'Liste aller Änderungen.md', data: 'aenderungsliste', type: 'text/plain' },
            { filename: 'copyleft.txt', data: 'copyleft', type: 'text/plain' }
        ] },
        html: 'Hier ein paar neue Dateien. Umlaute, Leerzeichen und Sonderzeichen sollten in Dateinamen vermieden werden. Das gibt nur Ärger. Verwende lieber <code>Ae</code> statt <code>Ä</code>, <code>ae</code> statt <code>ä</code>, <code>oe</code> statt <code>ö</code> usw. und statt Leerzeichen den Unterstrich <code>_</code>. Benenne alle Dateien so um.',
        onchange() {
            var file = this._root.getByPath('/traenenueberstroemt.jpg');
            if (!file || (file.data != 'foto'))
                return false;
            file = this._root.getByPath('/praesentation.odp');
            if (!file || (file.data != 'praesentation'))
                return false;
            file = this._root.getByPath('/Liste_aller_Aenderungen.md');
            if (!file || (file.data != 'aenderungsliste'))
                return false;
            file = this._root.getByPath('/copyleft.txt');
            if (!file || (file.data != 'copyleft'))
                return false;
            return (this._root._data.length == 4);
        }
    },
    {
        environment: { path: '/', files: [
            { filename: 'traenenueberstroemt.jpg', data: 'foto', type: 'image/jpeg' },
            { filename: 'praesentation.odp', data: 'praesentation', type: 'application/vnd.oasis.opendocument.presentation' },
            { filename: 'Liste_aller_Aenderungen.md', data: 'aenderungsliste', type: 'text/plain' },
            { filename: 'copyleft.txt', data: 'copyleft', type: 'text/plain' }
        ] },
        html: 'Entferne nun aus allen Dateinamen die Dateinamenserweiterung.',
        onchange() {
            var file = this._root.getByPath('/traenenueberstroemt');
            if (!file || (file.data != 'foto'))
                return false;
            file = this._root.getByPath('/praesentation');
            if (!file || (file.data != 'praesentation'))
                return false;
            file = this._root.getByPath('/Liste_aller_Aenderungen');
            if (!file || (file.data != 'aenderungsliste'))
                return false;
            file = this._root.getByPath('/copyleft');
            if (!file || (file.data != 'copyleft'))
                return false;
            return (this._root._data.length == 4);
        }
    },
    {
        environment: { path: '/', files: [
            { filename: 'traenenueberstroemt', data: 'foto', type: 'image/jpeg' },
            { filename: 'praesentation', data: 'praesentation', type: 'application/vnd.oasis.opendocument.presentation' },
            { filename: 'Liste_aller_Aenderungen', data: 'aenderungsliste', type: 'text/plain' },
            { filename: 'copyleft', data: 'copyleft', type: 'text/plain' }
        ] },
        html: 'Erstelle einen Ordner namens <code>praesentation</code>. (Hinweis: Diese Aufgabe kannst du nur lösen, wenn du zuvor noch etwas anderes machst…)',
        onchange() {
            var dir = this._root.getByPath('/praesentation');
            return (dir && dir.isDir);
        }
    }
];
window.FILESYSTEMSETTINGS = {
    useClipboard: false,
    levels: LEVELS
};
